diff --git b/net.sourceforge.eclipseccase.ui/plugin.xml a/net.sourceforge.eclipseccase.ui/plugin.xml
index 3f9d608..83efeb0 100644
--- b/net.sourceforge.eclipseccase.ui/plugin.xml
+++ a/net.sourceforge.eclipseccase.ui/plugin.xml
@@ -110,6 +110,11 @@
 				icon="icons/full/checkout.png" id="net.sourceforge.eclipseccase.popups.checkout"
 				label="Checkout" menubarPath="team.main/group1">
 			</action>
+         <action
+            class="net.sourceforge.eclipseccase.ui.actions.CompareWithChangeSetPredecessorAction"
+            icon="icons/full/diff.png" id="net.sourceforge.eclipseccase.popups.comparechangesetpredecessor2"
+            label="Change Set Predecessor" menubarPath="compareWithMenu/compareWithGroup">
+         </action>
 			<action
 				class="net.sourceforge.eclipseccase.ui.actions.CompareWithPredecessorAction"
 				icon="icons/full/diff.png" id="net.sourceforge.eclipseccase.popups.comparepredecessor2"
@@ -133,6 +138,11 @@
 				icon="icons/full/describe.png" id="net.sourceforge.eclipseccase.popups.describeversion"
 				label="Describe Version (external tool)" menubarPath="team.main/group2">
 			</action>
+         <action
+            class="net.sourceforge.eclipseccase.ui.actions.CompareWithChangeSetPredecessorAction"
+            icon="icons/full/diff.png" id="net.sourceforge.eclipseccase.popups.comparechangesetpredecessor"
+            label="Compare with Change Set Predecessor" menubarPath="team.main/group2">
+         </action>
 			<action
 				class="net.sourceforge.eclipseccase.ui.actions.CompareWithPredecessorAction"
 				icon="icons/full/diff.png" id="net.sourceforge.eclipseccase.popups.comparepredecessor"
@@ -308,6 +318,17 @@
 					</pluginState>
 				</enablement>
 			</action>
+         <action
+            class="net.sourceforge.eclipseccase.ui.actions.CompareWithChangeSetPredecessorAction"
+            definitionId="net.sourceforge.eclipseccase.ui.actionset.comparechangesetpredecessor"
+            icon="icons/full/diff.png" id="net.sourceforge.eclipseccase.ui.actionset.comparechangesetpredecessor"
+            label="&amp;Compare with Change Set Predecessor" menubarPath="eclipseccase_menu/group2"
+            toolbarPath="Normal/additions" tooltip="Compare with Change Set Predecessor">
+            <enablement>
+               <pluginState value="activated" id="net.sourceforge.eclipseccase">
+               </pluginState>
+            </enablement>
+         </action>
 			<action
 				class="net.sourceforge.eclipseccase.ui.actions.CompareWithPredecessorAction"
 				definitionId="net.sourceforge.eclipseccase.ui.actionset.comparepredecessor"
@@ -434,6 +455,11 @@
 			categoryId="net.sourceforge.eclipseccase.category"
 			id="net.sourceforge.eclipseccase.ui.actionset.comparepredecessor">
 		</command>
+      <command name="Compare with Change Set Predecessor"
+         description="Opens the clearcase compare with change set predecessor tool on the selected resources"
+         categoryId="net.sourceforge.eclipseccase.category"
+         id="net.sourceforge.eclipseccase.ui.actionset.comparechangesetpredecessor">
+      </command>
 		<command name="Compare with View"
             description="Opens the clearcase compare tool on the selected resource"
             categoryId="net.sourceforge.eclipseccase.category"
@@ -570,6 +596,10 @@
 			contextId="org.eclipse.ui.contexts.window" schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
 			sequence="Alt+C Alt+F">
 		</key>
+		<key commandId="net.sourceforge.eclipseccase.ui.actionset.comparechangesetpredecessor"
+         contextId="org.eclipse.ui.contexts.window" schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
+         sequence="Alt+C Alt+P">
+      </key>
 		<key commandId="net.sourceforge.eclipseccase.ui.actionset.comparepredecessor"
 			contextId="org.eclipse.ui.contexts.window" schemeId="org.eclipse.ui.defaultAcceleratorConfiguration"
 			sequence="Alt+C Alt+C">
@@ -636,6 +666,10 @@
 			commandId="net.sourceforge.eclipseccase.ui.actionset.findcheckouts"
 			schemeId="org.eclipse.ui.defaultAcceleratorConfiguration" sequence="Alt+C F">
 		</key>
+      <key platform="gtk"
+         commandId="net.sourceforge.eclipseccase.ui.actionset.comparechangesetpredecessor"
+         schemeId="org.eclipse.ui.defaultAcceleratorConfiguration" sequence="Alt+C P">
+      </key>		
 		<key platform="gtk"
 			commandId="net.sourceforge.eclipseccase.ui.actionset.comparepredecessor"
 			schemeId="org.eclipse.ui.defaultAcceleratorConfiguration" sequence="Alt+C C">
diff --git b/net.sourceforge.eclipseccase/src/net/sourceforge/eclipseccase/ClearCaseProvider.java a/net.sourceforge.eclipseccase/src/net/sourceforge/eclipseccase/ClearCaseProvider.java
index ad4f6e2..c636ba0 100644
--- b/net.sourceforge.eclipseccase/src/net/sourceforge/eclipseccase/ClearCaseProvider.java
+++ a/net.sourceforge.eclipseccase/src/net/sourceforge/eclipseccase/ClearCaseProvider.java
@@ -428,6 +428,11 @@ public class ClearCaseProvider extends RepositoryProvider {
 				.getPredecessorVersion();
 	}
 
+	public String getChangeSetPredecessorVersion(IResource resource) {
+		return StateCacheFactory.getInstance().get(resource)
+				.getChangeSetPredecessorVersion();
+	}
+
 	public void showVersionTree(String element, File workingDir) {
 		ClearCasePlugin.getEngine().showVersionTree(element, workingDir);
 
diff --git b/net.sourceforge.eclipseccase/src/net/sourceforge/eclipseccase/StateCache.java a/net.sourceforge.eclipseccase/src/net/sourceforge/eclipseccase/StateCache.java
index 8c66793..a9f0209 100644
--- b/net.sourceforge.eclipseccase/src/net/sourceforge/eclipseccase/StateCache.java
+++ a/net.sourceforge.eclipseccase/src/net/sourceforge/eclipseccase/StateCache.java
@@ -516,6 +516,16 @@ public class StateCache implements Serializable {
 	}
 
 	/**
+	 * Returns the change set predecessor version (/0).
+	 * 
+	 * @return String
+	 */
+	public String getChangeSetPredecessorVersion() {
+		String csPredecessorVersion = getVersion().replaceAll("/\\w+$", "/0");
+		return csPredecessorVersion;
+	}
+
+	/**
 	 * Returns the isUninitialized().
 	 * 
 	 * @return boolean